{
module Lex where

import Tokens
}

%wrapper "posn"

$digit = 0-9        -- digits
$alpha = [a-zA-Z]   -- alphabetic characters
$letter = $alpha 

tokens :-

  $white+;
  "//".* ;
  "&"{ \ p s -> Amp p }
  "{"{ \ p s -> LBrace p }
  "}"{ \ p s -> RBrace p }
  "["{ \ p s -> LBrack p }
  "]"{ \ p s -> RBrack p }
  "("{ \ p s -> LPar p }
  ")"{ \ p s -> RPar p }
  "<-"{ \ p s -> Ass p }
  "?"{ \ p s -> Ife p }
  ":"{ \ p s -> Colon p }
  ","{ \ p s -> Comma p }
  ";"{ \ p s -> Semicol p }
  "+"{ \ p s -> Plus p }
  "-"{ \ p s -> Minus p }
  "*"{ \ p s -> Times p }
  "/"{ \ p s -> Div p }
  "^^"{ \ p s -> Xor p }
  "&&"{ \ p s -> And p }
  "||"{ \ p s -> Or p }
  "<<"{ \ p s -> Lshift p }
  ">>"{ \ p s -> Rshift p }
  "<<#"{ \ p s -> Ashift p }
  "=="{ \ p s -> Eq p }
  "="{ \ p s -> Def p }
  "!="{ \ p s -> Ne p }
   "<#"{ \ p s -> ULt p }
 "<=#"{ \ p s -> ULe p }
  ">#"{ \ p s -> UGt p }
  ">=#"{ \ p s -> UGe p }
   "<"{ \ p s -> Lt p }
 "<="{ \ p s -> Le p }
  ">"{ \ p s -> Gt p }
  ">="{ \ p s -> Ge p }
  SET{ \ p s -> Set p }
  NAME{ \ p s -> Name p }
  VALUE{ \ p s -> Value p }
  JUMP{ \ p s -> Jump p }
  CJUMP{ \ p s -> CJump p }
  MEM{ \ p s -> Mem p }
  SEQ{ \ p s -> Seq p }
  EXP{ \ p s -> Exp p }
  CALL{ \ p s -> Call p }
  FCT{ \ p s -> Fct p }
  REG{ \ p s -> Reg p }
  LOC{ \ p s -> Loc p }
  ADR{ \ p s -> Adr p }
  FS{ \ p s -> FS p }
  $digit+{ \ p s -> Const (read s) p }
  "L" [$letter $digit \_ \' \$]*{ \ p s -> Label s p }
  "t" [$letter $digit \_ \' \$]*{ \ p s -> Register s p }
  $letter [$letter $digit \_ \' \$]*{ \ p s -> Id s p }
{
-- Each action has type :: String -> Token

-- The token type is in Token.hs
{-
main = do
  s <- getContents
  print (alexScanTokens s)
-}
}